/*
 Usage: ./send <systemCodeType> <systemCode> <unitCode> <command>
 SystemCodeType is 1 for default and 2 for switches with 10 Bits 123456ABCD
 Command is 0 for OFF and 1 for ON
 */

#include "RCSwitch.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[]) {
    
    /*
     output PIN is hardcoded for testing purposes
     see https://projects.drogon.net/raspberry-pi/wiringpi/pins/
     for pin mapping of the raspberry pi GPIO connector
     */
    int PIN = 0;
    int  systemCodeType = atoi(argv[1]);
    char* systemCode = argv[2];
    int unitCode = atoi(argv[3]);
    int command  = atoi(argv[4]);
    char* pSystemCode = systemCode;
    
    if (wiringPiSetup () == -1) return 1;
	printf("sending systemCode[%s] unitCode[%i] command[%i]\n", systemCode, unitCode, command);
	RCSwitch mySwitch = RCSwitch();
	mySwitch.enableTransmit(PIN);

    switch(systemCodeType) {
      case 1:
	switch(command) {
	case 1: mySwitch.switchOn(systemCode, unitCode);
		break;
	case 0: mySwitch.switchOff(systemCode, unitCode);
		break;
	default:
	printf("command{%i] is unsupported\n", command);
	return -1;
	}
      case 2:
   	switch(unitCode) {
	case 1: strcat(pSystemCode,"0FFF");
		break;
	case 2: strcat(pSystemCode,"F0FF");
		break;
	case 3: strcat(pSystemCode,"FFF0");
		break;
	case 4: strcat(pSystemCode,"FF0F");
		break;
	default:
	printf("unitCode[%i] is unsupported\n", unitCode);
	return -1;
	}
	switch(command) {
	case 0: strcat(pSystemCode,"0F");
		mySwitch.sendTriState(pSystemCode);
		break;
	case 1: strcat(pSystemCode,"F0");
		mySwitch.sendTriState(pSystemCode);
		break;
	default:
	printf("command[%i] is unsupported\n", command);
	return -1;
        }
    }
    return 0;
}
